/*
 *  Scheduler Handler
 *
 *  Copyright (C) 2010 Gedare Bloom.
 *
 *  The license and distribution terms for this file may be
 *  found in the file LICENSE in this distribution or at
 *  http://www.rtems.com/license/LICENSE.
 *
 *  $Id: schedulerprioritythreadschedulerfree.c,v 1.2 2010/11/25 13:24:26 sh Exp $
 */

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <rtems/system.h>
#include <rtems/config.h>
#include <rtems/score/chain.h>
#include <rtems/score/isr.h>
#include <rtems/score/object.h>
#include <rtems/score/scheduler.h>
#include <rtems/score/schedulerpriority.h>
#include <rtems/score/states.h>
#include <rtems/score/thread.h>
#include <rtems/score/wkspace.h>

/*
 *  _Scheduler_priority_Thread_scheduler_free
 *
 * Frees @a the_thread->scheduler
 *
 *  Input parameters:
 *    the_scheduler - pointer to scheduler control
 *    the_thread    - pointer to thread control block
 *
 *  Output parameters: NONE
 */

void _Scheduler_priority_Thread_scheduler_free (
    Scheduler_Control *the_scheduler __attribute__((unused)),
    Thread_Control    *the_thread
)
{
  _Workspace_Free( the_thread->scheduler.priority );
}
